/*
	by David L. O'Connor	11/13/91 LSC 5.0
*/

#include "animation.h"

/* the PICT resource id #'s
 */
#define natural		128
#define spider_1	2
#define spider_2	130
#define butterfly	131
#define moth		132
#define rock		133
#define ball		134
#define ball_2		400
#define background	135
#define balloon		136
#define stork		137
#define fish		138
#define moth_2		139
#define butterfly_2	140
#define bamboo		141
#define cat			142
#define bomb_1		150
#define bomb_2		151
#define bomb_3		152
#define bomb_4		153

/* the menu ids
 */
#define	appleid  (short) 128	
#define	fileid   (short) 129
#define	editid   (short) 130
#define	spriteid (short) 131

/* the window resource id #'s */
#define	game_window 128	

WindowPtr gamewindow, which_window;
WindowRecord winstorage;
Rect r, dragrect;
Point mouse_loc;
EventRecord gameevent;
MenuHandle gamemenu[4];
int done;
spriterecord sprite_1, sprite_2, sprite_3, mouse_sprite;

main() 
{	
	setup();
	while (! done)
		Handle_events();
	FlushEvents(everyEvent, 0);
	cleanupsprites();
	ExitToShell();
}

setup()
{
	init_mac();
	SetRect(&dragrect, qd.screenBits.bounds.left + 4, qd.screenBits.bounds.top + 4, qd.screenBits.bounds.right - 4, qd.screenBits.bounds.bottom - 4);
	gamewindow = GetNewWindow ( game_window, &winstorage, (WindowPtr) -1L );
	build_menus();
	SetPort(gamewindow);
	FillRect(&screenBits.bounds, dkGray);
	drawbackground();
	setupsprites();
}

/* pretty much straight from SAMP in I.M. */
Handle_events()
{
	static GrafPtr		old_port;
	
	if (GetNextEvent(everyEvent, &gameevent)){
		switch (gameevent.what){
			case mouseDown :
				switch (FindWindow(gameevent.where, &which_window)){
					case inMenuBar :
						docommand(MenuSelect(gameevent.where));
					break;
					case inSysWindow :
						SystemClick(&gameevent, which_window);
					break;
					case inGoAway:
						if (TrackGoAway(gamewindow, gameevent.where))
							done = 1;
					break;
					case inDrag :
						DragWindow(which_window, gameevent.where, &dragrect);
					break;
					case inContent :
						if (which_window != FrontWindow())
							SelectWindow(which_window);
					break;
				}
			break;
			case activateEvt :
				if (gameevent.modifiers & activeFlag)
					disable_edit_menu();
				else{
					enable_edit_menu();
					SetPort(gamewindow);
					}
			break;
			case updateEvt :
				GetPort(&old_port);
				SetPort(gamewindow);
				BeginUpdate(gamewindow);
				FillRect(&screenBits.bounds, dkGray);
				drawbackground();
				EndUpdate(gamewindow);
				SetPort(old_port);
			break;
			case nullEvent :
			break;
		}
	}
	else
		SystemTask();
	movesprites();
}

build_menus()
{
	register int i;
	
	InitMenus();
	gamemenu[0] = NewMenu(appleid, "\p\024");
	gamemenu[1] = NewMenu(fileid,  "\pFile");
	gamemenu[2] = NewMenu(editid,  "\pEdit");
	gamemenu[3] = NewMenu(spriteid,"\pFriends");
	AppendMenu(gamemenu[0],"\pAbout Fish & Friends...;(-");
	AddResMenu(gamemenu[0],'DRVR');
	AppendMenu(gamemenu[1],"\pQuit");
	AppendMenu(gamemenu[2],"\p(Undo;(-;(Cut;(Copy;(Paste;(Clear");
	AppendMenu(gamemenu[3],"\pFish;Spider_1;Spider_2;Moth_1;Moth_2;Butterfly_1;Mr. Natural;Balloon;Stork;Bamboo");
	for(i = 0; i < 4; i++)
		InsertMenu(gamemenu[i], 0);
	DrawMenuBar();
}

disable_edit_menu()
{
	DisableItem(gamemenu[2], 1);
	DisableItem(gamemenu[2], 3);
	DisableItem(gamemenu[2], 4);
	DisableItem(gamemenu[2], 5);
	DisableItem(gamemenu[2], 6);
}

enable_edit_menu()
{
	EnableItem(gamemenu[2], 1);
	EnableItem(gamemenu[2], 3);
	EnableItem(gamemenu[2], 4);
	EnableItem(gamemenu[2], 5);
	EnableItem(gamemenu[2], 6);
}

docommand(menu_selection)
long menu_selection;
{
	register int the_Item;
	static Str255 name;
	static Point mousept;
	
	the_Item = LoWord(menu_selection);
	switch (HiWord(menu_selection)){
		case appleid :
			if (the_Item == 1)
				Alert(128, 0L);
			else{
				GetItem(gamemenu[0], the_Item, name);
				OpenDeskAcc(name);
				SetPort(gamewindow);
			}
		break;
		case editid:
			SystemEdit(the_Item - 1);
		break;
		case fileid:
			switch (the_Item){
				case 1 :
					done = 1;
				break;
			}
		break;
		case spriteid:
			mousept.v = 300;
			mousept.h = 500;
			movesprite(&mouse_sprite, mousept);
			FillRect(&screenBits.bounds, dkGray);
			drawbackground();
			killsprite(&mouse_sprite, True);
			switch (the_Item){
				case 1 :
					if (! createsprite(&mouse_sprite,	fish, 0, STOPPED))
						badpic();
				break;
				case 2 :
					if (! createsprite(&mouse_sprite,	spider_1, 0, STOPPED))
						badpic();
				break;
				case 3 :
					if (! createsprite(&mouse_sprite,	spider_2, 0, STOPPED))
						badpic();
				break;
				case 4 :
					if (! createsprite(&mouse_sprite,	moth, 0, STOPPED))
						badpic();
				break;
				case 5 :
					if (! createsprite(&mouse_sprite,	moth_2, 0, STOPPED))
						badpic();
				break;
				case 6 :
					if (! createsprite(&mouse_sprite,	butterfly, 0, STOPPED))
						badpic();
				break;
				case 7 :
					if (! createsprite(&mouse_sprite,	natural, 0, STOPPED))
						badpic();
				break;
				case 8 :
					if (! createsprite(&mouse_sprite,	balloon, 0, STOPPED))
						badpic();
				break;
				case 9 :
					if (! createsprite(&mouse_sprite,	stork, 0, STOPPED))
						badpic();
				break;
				case 10 :
					if (! createsprite(&mouse_sprite,	bamboo, 0, STOPPED))
						badpic();
				break;
			}
		break;
	}
	HiliteMenu(0);
}

/************************* Sprite Stuff ******************************/

setupsprites()
{	
	register Point location;
	
	if(initsprites(&gamewindow->portRect) == False)
		badinit();
	if (! createsprite(&mouse_sprite,	fish , 	  0, STOPPED))
		badpic();
	if (! createsprite(&sprite_1, 		ball, 	20, RIGHT))
		badpic();	
	if (! createsprite(&sprite_2,		rock, 	  15, RIGHT))
		badpic();
	if (! createsprite(&sprite_3,		cat, 	 30, RIGHT))
		badpic();
		
	location.h = 250;
	location.v = 125;
	movesprite(&sprite_1, location);
	display(&sprite_1.update_r, &gamewindow->portBits);		
	fixupsprite(&sprite_1);
	
	location.h = 200;
	location.v = 100;
	movesprite(&sprite_2, location);
	display(&sprite_2.update_r, &gamewindow->portBits);
	fixupsprite(&sprite_2);
	
	location.h = 50;
	location.v = 175;
	movesprite(&sprite_3, location);
	display(&sprite_3.update_r, &gamewindow->portBits);	
	fixupsprite(&sprite_3);
}

drawbackground()
{	
	register PicHandle	 background_pic;
	
	background_pic = (PicHandle) GetPicture(background);
	if (background_pic == Nil)
		badpic();
	DrawPicture(background_pic, &((**background_pic).picFrame));
}

badinit()
{		
	ShowCursor();
	Alert(129, Nil);
	ExitToShell();
}

badpic()
{		
	ShowCursor();
	Alert(130, Nil);
	ExitToShell();
}

movesprites()
{	
	static Rect r;
	static Point mousept;
	
	check_boundries();
	GetMouse(&mousept);
	
	movesprite(&sprite_1,		next_loc(&sprite_1));
	movesprite(&mouse_sprite,	mousept);
	movesprite(&sprite_2,		next_loc(&sprite_2));
	movesprite(&sprite_3,		next_loc(&sprite_3));
	
	increment_direction(&sprite_2, 10);
	
	UnionRect(&sprite_1.update_r, &mouse_sprite.update_r, &r);
	UnionRect(&sprite_2.update_r, &r, &r);
	UnionRect(&sprite_3.update_r, &r, &r);
	
	display(&r, &gamewindow->portBits);
	
	fixupsprite(&sprite_3);
	fixupsprite(&sprite_2);
	fixupsprite(&mouse_sprite);
	fixupsprite(&sprite_1);

}

check_boundries()
{	
	if (sprite_1.drag_r.left <= 10)
		set_direction(&sprite_1, RIGHT);
	else if (sprite_1.drag_r.right >= 600)
		set_direction(&sprite_1, LEFT);
		
	/*
	if (sprite_2.drag_r.left <= 10)
		set_direction(&sprite_2, RIGHT);
	else if (sprite_2.drag_r.right >= 600)
		set_direction(&sprite_2, LEFT);
	*/
	
	if (sprite_3.drag_r.left <= 10)
		set_direction(&sprite_3, RIGHT);
	else if (sprite_3.drag_r.right >= 600)
		set_direction(&sprite_3, LEFT);
}

cleanupsprites()
{
	killsprite(&sprite_2, True);
	killsprite(&sprite_3, True);
	killsprite(&sprite_1, True);
	killsprite(&mouse_sprite, True);
	closesprites(True);
}