/* animation.h - header for animation program 

	Copyright 1993 David L. O'Connor 
	04/16/93 Think C 5.0
*/

/*   #define USE_COPYBITS 1 	use CopyBits with clipping region instead of CopyMask */

typedef struct	{
	BitMap		picturebits;		/* the picture's image */	
	BitMap		picturemask;		/* the picture's mask */
	BitMap		underbits;			/* where screen under picture is saved */
#ifdef USE_COPYBITS
	RgnHandle		maskRgn;			/* the mask's region for CopyBits clipping region*/
	RgnHandle		underbitsRgn;		/* the underbits's region for CopyBits clipping region*/
#endif
	Rect			last_r;			/* the last screen update boundry */
	Rect			update_r;			/* the union of all that needs update */
	Rect			drag_r;			/* where we draw the picture */
	int			status;			/* are we Alive or Dead */
	int			speed;			/* our speed */
	int			direction;			/* our direction in degrees, 0 - 360 */
	int			pic_h;			/* our picture's rect's width */
	int			pic_v; 			/* our picture's rect's height */
	} spriterecord;					/* finally, our movable PICT !!! */
	
/* some common directions */
#define	STOPPED		 -1
#define	RIGHT		  0
#define	UP_RIGHT	 	45
#define	UP			 90
#define	UP_LEFT		135
#define	LEFT			180
#define	DOWN_LEFT	225
#define	DOWN		270
#define	DOWN_RIGHT	315

#define True	1 
#define False	0 
#define Alive  	1 
#define Dead 	0 
#define Nil	0L 

extern BitMap offscreenbits;
double sin(), cos();
Point next_loc(), global_mouse_loc();
